/* LCM type definition class file
 * This file was automatically generated by lcm-gen
 * DO NOT MODIFY BY HAND!!!!
 */

package gpslcm;
 
import java.io.*;
import java.util.*;
import lcm.lcm.*;
 
public final class gps_lcm implements lcm.lcm.LCMEncodable
{
    public int time;
    public double latitude;
    public String ns;
    public double longitude;
    public String sw;
    public int altitude;
    public int hour;
    public int minute;
    public int second;
    public int lat_deg;
    public int lat_cent;
    public int lat_sec;
    public int long_deg;
    public int long_cent;
    public int long_sec;
    public double utm_x;
    public double utm_y;
    public int utm_zonenumber;
    public String utm_zoneletter;
    public String gpgga;
 
    public gps_lcm()
    {
    }
 
    public static final long LCM_FINGERPRINT;
    public static final long LCM_FINGERPRINT_BASE = 0x202a0dcb8185d9c7L;
 
    static {
        LCM_FINGERPRINT = _hashRecursive(new ArrayList<Class<?>>());
    }
 
    public static long _hashRecursive(ArrayList<Class<?>> classes)
    {
        if (classes.contains(gpslcm.gps_lcm.class))
            return 0L;
 
        classes.add(gpslcm.gps_lcm.class);
        long hash = LCM_FINGERPRINT_BASE
            ;
        classes.remove(classes.size() - 1);
        return (hash<<1) + ((hash>>63)&1);
    }
 
    public void encode(DataOutput outs) throws IOException
    {
        outs.writeLong(LCM_FINGERPRINT);
        _encodeRecursive(outs);
    }
 
    public void _encodeRecursive(DataOutput outs) throws IOException
    {
        char[] __strbuf = null;
        outs.writeInt(this.time); 
 
        outs.writeDouble(this.latitude); 
 
        __strbuf = new char[this.ns.length()]; this.ns.getChars(0, this.ns.length(), __strbuf, 0); outs.writeInt(__strbuf.length+1); for (int _i = 0; _i < __strbuf.length; _i++) outs.write(__strbuf[_i]); outs.writeByte(0); 
 
        outs.writeDouble(this.longitude); 
 
        __strbuf = new char[this.sw.length()]; this.sw.getChars(0, this.sw.length(), __strbuf, 0); outs.writeInt(__strbuf.length+1); for (int _i = 0; _i < __strbuf.length; _i++) outs.write(__strbuf[_i]); outs.writeByte(0); 
 
        outs.writeInt(this.altitude); 
 
        outs.writeInt(this.hour); 
 
        outs.writeInt(this.minute); 
 
        outs.writeInt(this.second); 
 
        outs.writeInt(this.lat_deg); 
 
        outs.writeInt(this.lat_cent); 
 
        outs.writeInt(this.lat_sec); 
 
        outs.writeInt(this.long_deg); 
 
        outs.writeInt(this.long_cent); 
 
        outs.writeInt(this.long_sec); 
 
        outs.writeDouble(this.utm_x); 
 
        outs.writeDouble(this.utm_y); 
 
        outs.writeInt(this.utm_zonenumber); 
 
        __strbuf = new char[this.utm_zoneletter.length()]; this.utm_zoneletter.getChars(0, this.utm_zoneletter.length(), __strbuf, 0); outs.writeInt(__strbuf.length+1); for (int _i = 0; _i < __strbuf.length; _i++) outs.write(__strbuf[_i]); outs.writeByte(0); 
 
        __strbuf = new char[this.gpgga.length()]; this.gpgga.getChars(0, this.gpgga.length(), __strbuf, 0); outs.writeInt(__strbuf.length+1); for (int _i = 0; _i < __strbuf.length; _i++) outs.write(__strbuf[_i]); outs.writeByte(0); 
 
    }
 
    public gps_lcm(byte[] data) throws IOException
    {
        this(new LCMDataInputStream(data));
    }
 
    public gps_lcm(DataInput ins) throws IOException
    {
        if (ins.readLong() != LCM_FINGERPRINT)
            throw new IOException("LCM Decode error: bad fingerprint");
 
        _decodeRecursive(ins);
    }
 
    public static gpslcm.gps_lcm _decodeRecursiveFactory(DataInput ins) throws IOException
    {
        gpslcm.gps_lcm o = new gpslcm.gps_lcm();
        o._decodeRecursive(ins);
        return o;
    }
 
    public void _decodeRecursive(DataInput ins) throws IOException
    {
        char[] __strbuf = null;
        this.time = ins.readInt();
 
        this.latitude = ins.readDouble();
 
        __strbuf = new char[ins.readInt()-1]; for (int _i = 0; _i < __strbuf.length; _i++) __strbuf[_i] = (char) (ins.readByte()&0xff); ins.readByte(); this.ns = new String(__strbuf);
 
        this.longitude = ins.readDouble();
 
        __strbuf = new char[ins.readInt()-1]; for (int _i = 0; _i < __strbuf.length; _i++) __strbuf[_i] = (char) (ins.readByte()&0xff); ins.readByte(); this.sw = new String(__strbuf);
 
        this.altitude = ins.readInt();
 
        this.hour = ins.readInt();
 
        this.minute = ins.readInt();
 
        this.second = ins.readInt();
 
        this.lat_deg = ins.readInt();
 
        this.lat_cent = ins.readInt();
 
        this.lat_sec = ins.readInt();
 
        this.long_deg = ins.readInt();
 
        this.long_cent = ins.readInt();
 
        this.long_sec = ins.readInt();
 
        this.utm_x = ins.readDouble();
 
        this.utm_y = ins.readDouble();
 
        this.utm_zonenumber = ins.readInt();
 
        __strbuf = new char[ins.readInt()-1]; for (int _i = 0; _i < __strbuf.length; _i++) __strbuf[_i] = (char) (ins.readByte()&0xff); ins.readByte(); this.utm_zoneletter = new String(__strbuf);
 
        __strbuf = new char[ins.readInt()-1]; for (int _i = 0; _i < __strbuf.length; _i++) __strbuf[_i] = (char) (ins.readByte()&0xff); ins.readByte(); this.gpgga = new String(__strbuf);
 
    }
 
    public gpslcm.gps_lcm copy()
    {
        gpslcm.gps_lcm outobj = new gpslcm.gps_lcm();
        outobj.time = this.time;
 
        outobj.latitude = this.latitude;
 
        outobj.ns = this.ns;
 
        outobj.longitude = this.longitude;
 
        outobj.sw = this.sw;
 
        outobj.altitude = this.altitude;
 
        outobj.hour = this.hour;
 
        outobj.minute = this.minute;
 
        outobj.second = this.second;
 
        outobj.lat_deg = this.lat_deg;
 
        outobj.lat_cent = this.lat_cent;
 
        outobj.lat_sec = this.lat_sec;
 
        outobj.long_deg = this.long_deg;
 
        outobj.long_cent = this.long_cent;
 
        outobj.long_sec = this.long_sec;
 
        outobj.utm_x = this.utm_x;
 
        outobj.utm_y = this.utm_y;
 
        outobj.utm_zonenumber = this.utm_zonenumber;
 
        outobj.utm_zoneletter = this.utm_zoneletter;
 
        outobj.gpgga = this.gpgga;
 
        return outobj;
    }
 
}

